# The economics of cloud computing

## Cloud Computing Service Model (Not important)

### Service oriented Technology

- Properties
    - Logical view: abstraction of actual processes
    - Message orientation: uses message to communicate
    - Description orientation: described by machine executable metadata
    - Granularity: use small operation, in order to perform complex tasks
    - Network orientation: offered through networks
    - Platform neutrality: standardized format
- Examples: SaaS, PaaS, IaaS

### Objectives:

- Shift computing, thus management and maintainence
- High QoS
- Transparent, and generic standards to boost acceptability

## Economic models

### Traditional cost model

- Upfront capital costs (CAPEX, capital expenditure): money spent at the
  beginning of business to get the equipment
- Variable cost (OPEX, Operational expenditure): operational cost
- Calculation:
    - Upfront capital costs + Variable costs

### Cloud cost model

- Calculation
    - Variable costs (no upfront cost)
    - Traditional IT cost minus the upfront capital costs (This sounds stupid
      and absurd, I hope the profs are not going to make a quiz on this)
- Optimizing
    - AWS Trusted Advisor: online service, that helps suggesting ways to
      optimize costs
    - Calculators:
        - TCO: Total cost of ownership calculator, estimate the cost savings
          when using AWS, compared to traditional IT systems
        - Simple Monthly Calculator: estimate your AWS monthly bills, based on
          business requirements

### Examples

- Amazon cloud options:
    - Reserved:
        - Reserved capacity: reserve for 1 to 3 years to get discount
        - Reserved instances:
            - All-Upfront RI: Pay everything at once to get huge discount
            - Partial-Upfront RI: Pay part of the amount and get less savings
            - No-Upfront RI: Pay nothing upfront, little saving
    - On-demand instance: Pay as you go
    - Dedicated instance: run on physical server
    - Free: 12 months of free EC2

### Motivation for both parties

#### Subscribers:

- Cost savings
    - Power
    - Support, Maintainence
    - Software licenses
    - Increased profit
- Fancy words
    - Innovation
    - Productivity
    - Competitive advantage
    - Elastic
- Development experience
    - Automation
    - Reliability
    - Scalability

#### Providers

- Shared resource, no waste
- Location independent
- Variety of customers that can serve

## Competition

- Offerings
    - Free and educational
    - Reserved
    - Novelties: glacier file storage
- Assurance
    - Risk mitigation
    - Reputation
    - Size

## All kinds of models

### Service delivery

- Definition: pre-packaged combination of IT resources, offered by cloud
  provider as service
- Examples: [previous slide](/1-1-intro.md#cloud-service-models)

### Deployment

- Private cloud: on premises cloud
- Public cloud
- Community cloud: infra is shared between several organizations
- Hybrid cloud: public cloud with a private cloud, or on-premises data center

## Challenges and opportunities:

### Challenges

- Demand on features and support
- [Competition](#competition)
- [QoS](/1-2-sla-virtualization.md#qos)
- [SLA](/1-2-sla-virtualization.md#sla)

### Opportunities

- Jobs:
    - AWS Cloud Practitioner
    - AWS Solution Architect
    - AWS Developer
    - AWS DevOps Engineer
    - AWS SysOps Administrator
    - AWS Security Expert
    - AWS Big Data Expert
    - AWS Networking Expert
    - AWS Data Engineer
    - AWS Data Scientist
